// Globals
// --------------------------------------------------
var glb_animate_class = 'animated';

var glb_animate_class_in = 'fadeIn';
var glb_animate_class_out = 'fadeOut';

var glb_animate_layout_class_in = '';
var glb_animate_layout_class_out = '';

var glb_animate_page_class_in = '';
var glb_animate_page_class_out = '';

var glb_animate_layer_class_in = '';
var glb_animate_layer_class_out = '';

var glb_animate_tip_class_in = 'bounceInDown';
var glb_animate_tip_class_out = 'bounceOutLeft';

var glb_animate_panel_class_in = '';
var glb_animate_panel_class_out = '';

var glb_swipers = [];


var bindClickToElement;
var bindInputTargetOptions;

// Ready
// --------------------------------------------------
$(document).ready(function() {
 //window.localStorage.clear();
  // Click to element
  // -------------------------
  bindClickToElement = function() {
    console.log('bindClickToElement');
    $('.click-to-element').on('click', function (e) {
    e.preventDefault();
    e.stopPropagation();

    var selector = $(this).attr('data-click-to-selector');
    if(selector === undefined)
      selector = '#layout-login';

    if((selector == '#layout-login' || selector === undefined)  && permanentStorage.getItem('id_percorso'))
      selector = '#layout-home';
    else {
      if((selector == '#layout-login' || selector === undefined)  && !permanentStorage.getItem('id_percorso') && permanentStorage.getItem('username'))
        selector = '#layer-login-photo-upload';
    }

    if (selector == 'undefined') return false;
    
    if (selector.length <= 0) return false;

    var animate_class_out = $(this).attr('data-click-to-animate-class-out');
    var animate_class_in = $(selector).attr('data-click-to-animate-class-in');
    var overlay = $(this).attr('data-click-to-overlay');

    // Try to manage queued anim
    // !IMP: Only for click-to-element

    var selectors = selector.split(',');
    var animate_class_outs = (!animate_class_out || animate_class_out.length == 0) ? [] : animate_class_out.split(',');
    var animate_class_ins = (!animate_class_in || animate_class_in.length == 0) ? [] : animate_class_in.split(',');
    var overlays = (!overlay || overlay.length == 0) ? [] : overlay.split(',');

    animate_class_outs.length = selectors.length;
    animate_class_ins.length = selectors.length;
    overlays.length = selectors.length;

    for (i = 0; i < selectors.length; i++) {

      selector = selectors[i].trim();
      animate_class_out = (!animate_class_outs[i]) ? '' : animate_class_outs[i].trim();
      animate_class_in = (!animate_class_ins[i]) ? '' : animate_class_ins[i].trim();
      overlay = (!overlays[i]) ? false : overlays[i].toLowerCase().trim() == 'true';
      // console.log(i + ': ' + selector + ' > ' + animate_class_out + ' > ' + animate_class_in + ' > ' + overlay);

      // !IMP: overlay is only implemented for click to layers
      $(document).gotoElement(selector, animate_class_out, animate_class_in, overlay);

    }

    return false;

    });
    console.log('bindClickToElement ok');
  };
  bindClickToElement();

  // Swipe to element
  // -------------------------
  $('.swipe-to-element').hammer().bind('swipe', function(e) {

    // console.log(e);
    e.preventDefault();
    e.stopPropagation();

    var direction = '';
    switch (e.gesture.direction) {
      case Hammer.DIRECTION_LEFT:
        direction = 'left';
        break;
      case Hammer.DIRECTION_RIGHT:
        direction = 'right';
        break;
      default:
    }

    var selector = $(this).attr('data-swipe-' + direction + '-to-selector');
    // console.log('#' + $(this).attr('id') + '(' + direction + ')>' + selector);

    if (selector.length <= 0) {
      // console.log(e.gesture.srcEvent);
      // e.gesture.srcEvent.preventDefault(); // !IMP: Prevent cancelable=false warning
      e.gesture.srcEvent.stopPropagation();
      return false;
    }

    var animate_class_out = $(this).attr('data-swipe-' + direction + '-to-animate-class-out');
    var animate_class_in = $(selector).attr('data-swipe-' + direction + '-to-animate-class-in');
    $(document).gotoElement(selector, animate_class_out, animate_class_in);

    return false;

  });
  
  // Swipe toggle class
  // -------------------------
  $('.swipe-toggle-class').hammer().bind('swipe', function(e) {

    // console.log(e);
    e.preventDefault();
    e.stopPropagation();

    var direction = '';
    switch (e.gesture.direction) {
      case Hammer.DIRECTION_LEFT:
        direction = 'left';
        break;
      case Hammer.DIRECTION_RIGHT:
        direction = 'right';
        break;
      default:
    }

    var toggle_left_class = $(this).attr('data-swipe-left-toggle-class');
    var toggle_right_class = $(this).attr('data-swipe-right-toggle-class');
    var toggle_class = $(this).attr('data-swipe-' + direction + '-toggle-class');
    // console.log('#' + $(this).attr('id') + '(' + direction + ')>' + toggle_class);

    if (toggle_class.length >= 0) {
      // console.log(e.gesture.srcEvent);
      // e.gesture.srcEvent.preventDefault(); // !IMP: Prevent cancelable=false warning
      e.gesture.srcEvent.stopPropagation();
      // return false;
    }

    switch (direction) {
      case "left":
        if ($(this).hasClass(toggle_right_class)) {
          $(this).toggleClass(toggle_right_class);
        } else if (!$(this).hasClass(toggle_class)) {
          $(this).toggleClass(toggle_class);
        }
        break;
      case "right":
        if ($(this).hasClass(toggle_left_class)) {
          $(this).toggleClass(toggle_left_class);
        } else if (!$(this).hasClass(toggle_class)) {
          $(this).toggleClass(toggle_class);
        }
        break;
      default:
    }

    return false;

  });

  // Trigger to element
  // -------------------------
  $('.trigger-to-element').on('click', function(e) {

    e.preventDefault();
    e.stopPropagation();

    var trigger_selector = $(this).attr('data-trigger-to-selector');
    if (trigger_selector.length <= 0) return false;

    var trigger_event = $(this).attr('data-trigger-to-event');
    switch (trigger_event) {
      case 'click':
        $(trigger_selector).trigger(trigger_event);
        break;
      case 'swipe-left':
      case 'swipe-right':
        // Tried to manually trigger swipe event, it's a bloody way
        var direction = trigger_event.substring(trigger_event.indexOf('-') + 1);
        var selector = $(trigger_selector).attr('data-swipe-' + direction + '-to-selector');
        var animate_class_out = $(trigger_selector).attr('data-swipe-' + direction + '-to-animate-class-out');
        var animate_class_in = $(selector).attr('data-swipe-' + direction + '-to-animate-class-in');
        $(document).gotoElement(selector, animate_class_out, animate_class_in);
        break;
      default:
        break;
    }

    return false;

  });

  // Input target options
  // -------------------------
  bindInputTargetOptions = function() {
    $('.input-target-options a').on('click', function(e) {
    e.preventDefault();
    e.stopPropagation();

    $(this).parent().find('a').removeClass('active');
    $(this).addClass('active');

    var selector = $(this).parent().attr('data-input-target');
    var value = $(this).attr('data-input-value');
    $(selector).val(value);

    return false;
    });
  };
  bindInputTargetOptions();

  // Input target toggle
  // -------------------------
  $('.input-target-toggle').on('change', function(e) {

    // e.preventDefault();
    // e.stopPropagation();

    var selector = $(this).attr('data-input-target');
    var value = $(this).is(':checked');
    $(selector).val(value);

    var selector_placeholder = $(this).attr('data-toggle-placeholder');
    var selector_placeholder_on = $(this).attr('data-toggle-placeholder-on');
    var selector_placeholder_off = $(this).attr('data-toggle-placeholder-off');
    var placeholder = (value) ? selector_placeholder_on : selector_placeholder_off;
    $(selector_placeholder).text(placeholder);

    // return false;

  });

// Input swiper
  // -------------------------
  $('.input-target-swiper').each(function() {

    var swiper_selector = '#' + $(this).attr('id');
    // console.log(swiper_selector);

    glb_swipers[swiper_selector] = $(swiper_selector).swiper({
      slidesPerView: 7,
      offsetSlidesBefore: 3,
      offsetSlidesAfter: 3,
      watchActiveIndex: true,
      mode: 'vertical',
      loop: false
    });

    var input_selector = $(this).attr('data-input-target');
    var input_value = parseInt('0' + $(input_selector).val());
    // console.log(input_selector + ': ' + input_value);

    glb_swipers[swiper_selector].swipeTo(input_value);

  });

  $('.input-confirm-swiper').on('click', function() {

    $(this).parents('.input-swiper').first().find('.input-target-swiper').each(function() {

      var swiper_selector = '#' + $(this).attr('id');
      // console.log(swiper_selector);

      var input_selector = $(this).attr('data-input-target');
      var input_value = glb_swipers[swiper_selector].activeIndex;
      input_value = (input_value < 10) ? '0' + input_value : input_value;
      // console.log(input_selector + ': ' + input_value);

      $(input_selector).val(input_value);

      var selector_placeholder = $(this).attr('data-swiper-placeholder');
      $(selector_placeholder).text(input_value);

    });

  });



  // Collapse
  // -------------------------
  // $('.collapse').collapse('hide');
  $('.group-content').on('click', function(e) {

    // e.preventDefault();
    // e.stopPropagation();

    $(this).find('.group-arrow').toggleClass('active');

    // return false;

  });

  // Page XX flow activation
  // -------------------------
    $('.layout#layout-launch').click();

});


// // Load
// // --------------------------------------------------
// $(window).load(function() {

// });


// // Resize
// // --------------------------------------------------
// $(window).resize(function() {

// });


// Extend
// --------------------------------------------------
$.fn.extend({

  gotoElement: function(selector, animate_class_out, animate_class_in, overlay, callback_before, callback_after) {

    // !IMP: overlay is only implemented for click to layers
    console.log('gotoElement: '+selector);

    // Exit condition
    if ((selector.length <= 0) ||
      ($(selector).length <= 0)) {
      return false;
    }

    // Callback before
    if (callback_before && typeof callback_before === "function") {
      callback_before();
    }

    // De-Overlay: if target is NOT inside current overlay
    if ($(selector).parents('.overlay').length <= 0) {
      $('.overlay').each(function() {

        var overlay_class_out = $(this).attr('data-click-to-animate-class-out');
        var overlay_class_in = $(this).attr('data-click-to-animate-class-in');

        overlay_class_in = overlay_class_in || glb_animate_class_in;
        overlay_class_out = overlay_class_out || glb_animate_class_out;

        $(this).addClass(glb_animate_class + ' ' + overlay_class_out)
          .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

            // De-Overlay current layer
            $(this).removeClass('overlay ' + glb_animate_class + ' ' + overlay_class_in + ' ' + overlay_class_out);

          });

      });
    }

    // Exit condition
    if ((!overlay && $(selector).hasClass('active')) ||
      (overlay && $(selector).hasClass('overlay'))) {
      return false;
    }

    // !IMP: First class is element type
    var type = $(selector).attr('class').split(' ')[0];
    // console.log(type);

    switch (type) {
      case 'layout':
        $(document).gotoLayout(selector,
          animate_class_out, animate_class_in);
        break;
      case 'page':
        $(document).gotoPage(selector,
          animate_class_out, animate_class_in);
        break;
      case 'layer':
        $(document).gotoLayer(selector,
          animate_class_out, animate_class_in, overlay);
        break;
      case 'tip':
        $(document).gotoTip(selector,
          animate_class_out, animate_class_in);
        break;
      case 'panel':
        $(document).gotoPanel(selector,
          animate_class_out, animate_class_in);
        break;
      default:
    }

    // Callback after
    if (callback_after && typeof callback_after === "function") {
      callback_after();
    }

    // !IMP: Swipers ResizeFix !
    $(selector).find('.input-target-swiper').each(function() {

      var swiper_selector = '#' + $(this).attr('id');
      var computed_height = $(swiper_selector).parents('.swiper-height').height();
      // console.log(swiper_selector + ': ' + computed_height);

      $(swiper_selector).height(computed_height);

      glb_swipers[swiper_selector].resizeFix();

      var input_selector = $(this).attr('data-input-target');
      var input_value = parseInt('0' + $(input_selector).val());
      // console.log(input_selector + ': ' + input_value);

      glb_swipers[swiper_selector].swipeTo(input_value);

    });

  },

  gotoLayout: function(selector, animate_class_out, animate_class_in) {

    return this.each(function() {

      // Move to (selector) target layout
      animate_class_in = animate_class_in || glb_animate_layout_class_in || glb_animate_class_in;
      animate_class_out = animate_class_out || glb_animate_layout_class_out || glb_animate_class_out;

      $('.layout.active').addClass(glb_animate_class + ' ' + animate_class_out)
        .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

          // Activate first page of target layout
          $(selector).find('.page').removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);
          $(selector).find('.page:first-child').addClass('active');

          // Activate first layer of target page
          $(selector).find('.page .layer').removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);
          $(selector).find('.page .layer:first-child').addClass('active');

          // Activate target layer
          $(selector).addClass('active ' + glb_animate_class + ' ' + animate_class_in)
            .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
              $(this).removeClass(glb_animate_class + ' ' + animate_class_in);
            });

          // De-activate current layout and all pages, layers
          $(this).removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);
          $(this).find('.page, .page .layer').removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);

        });

    });

  },

  gotoPage: function(selector, animate_class_out, animate_class_in) {

    return this.each(function() {

      // Move to (selector) target page
      animate_class_in = animate_class_in || glb_animate_page_class_in || glb_animate_class_in;
      animate_class_out = animate_class_out || glb_animate_page_class_out || glb_animate_class_out;

      $('.page.active').addClass(glb_animate_class + ' ' + animate_class_out)
        .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

          // Activate first layer of target page
          $(selector).find('.layer').removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);
          $(selector).find('.layer:first-child').addClass('active');

          // Activate target page
          $(selector).addClass('active ' + glb_animate_class + ' ' + animate_class_in)
            .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
              $(this).removeClass(glb_animate_class + ' ' + animate_class_in);
            });

          // De-activate current page and all layers
          $(this).removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);
          $(this).find('.layer').removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);

        });

    });

  },

  gotoLayer: function(selector, animate_class_out, animate_class_in, overlay) {

    return this.each(function() {
    console.log('gotoLayer: '+selector);
      // Move to (selector) target layer
      animate_class_in = animate_class_in || glb_animate_layer_class_in || glb_animate_class_in;
      animate_class_out = animate_class_out || glb_animate_layer_class_out || glb_animate_class_out;

      if (overlay) {

        // Overlay target layer
        $(selector).addClass('overlay ' + glb_animate_class + ' ' + animate_class_in)
          .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
            $(this).removeClass(glb_animate_class + ' ' + animate_class_in);
          });

      } else {

        // Activate target layer
        $('.layer.active').addClass(glb_animate_class + ' ' + animate_class_out)
          .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

            // Activate target layer
            $(selector).addClass('active ' + glb_animate_class + ' ' + animate_class_in)
              .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
                $(this).removeClass(glb_animate_class + ' ' + animate_class_in);
              });

            // De-activate current layer
            $(this).removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);

          });

      }

    });

  },

  gotoTip: function(selector, animate_class_out, animate_class_in) {

    return this.each(function() {

      // Move to (selector) target tip
      animate_class_in = animate_class_in || glb_animate_tip_class_in || glb_animate_class_in;
      animate_class_out = animate_class_out || glb_animate_tip_class_out || glb_animate_class_out;

      $('.tip.active').addClass(glb_animate_class + ' ' + animate_class_out)
        .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

          // Activate target tip
          $(selector).addClass('active ' + glb_animate_class + ' ' + animate_class_in)
            .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
              $(this).removeClass(glb_animate_class + ' ' + animate_class_in);
            });

          // De-activate current tip
          $(this).removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);

        });

    });

  },

  gotoPanel: function(selector, animate_class_out, animate_class_in) {

    return this.each(function() {

      // Move to target Panel
      animate_class_in = animate_class_in || glb_animate_panel_class_in || glb_animate_class_in;
      animate_class_out = animate_class_out || glb_animate_panel_class_out || glb_animate_class_out;

      // Activate target panel
      $(selector).addClass('active ' + glb_animate_class + ' ' + animate_class_in);

      // Hook De-activation button
      $(selector).find('.panel-close').on('click', function(e) {

        e.preventDefault();
        e.stopPropagation();

        $(this).parents('.panel').first().addClass(glb_animate_class + ' ' + animate_class_out)
          .one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {

            // De-activate panel
            $(this).removeClass('active ' + glb_animate_class + ' ' + animate_class_in + ' ' + animate_class_out);

          });

        return false;


      });

    });

  }

});

